unit Utility;
interface
uses Windows,Messages;

Type
  TVSSPFunc=Function(Parent:hWnd):Bool; StdCall;
  TPCPAFunc=Function(A:PChar;Parent:hWnd;B,C:Integer):Integer; StdCall;

Var
  IsPreview,QuitSaver,SolidColors:Boolean;
  BlockType:byte;
  MoveCounter,MaxX,MaxY,Delay:Integer;
  PreviewWindow:hWnd;

Procedure RunScreenSaver;

implementation
//      
function MyStrToInt(S:string):integer;
const
  Pos0=ord('0');
var
  i,j,k:integer;
begin
  j:=Length(S);
  Result:=0;
  if S[1]='-' then k:=2 else k:=1;
  for i:=k to j do Result:=Result*10+ord(S[i])-Pos0;
  if k=2 then Result:=-Result;
end;
//      
{function MyIntToStr(K:integer):string;
const
  Pos0=ord('0');
var
  j:integer;
  TempS:string;
begin
  if K<0 then
  begin
    Result:='-';
    K:=-K;
  end
  else Result:='';
  TempS:='';
  repeat
    j:=K mod 10;
    K:=K div 10;
    TempS:=chr(Pos0+j)+TempS;
  until K=0;
  Result:=Result+TempS;
end;}
//-----  
Procedure DrawSingleBox;
Var
  PaintDC  : hDC;
  Info     : TPaintStruct;
  OldBrush : hBrush;
  OldPen   : HPen;
  X,Y,W,H  : Integer;
  Color    : LongInt;
  R,G,B,N  : byte;
  Pro      : boolean;
Begin
  PaintDC:=BeginPaint(PreviewWindow,Info);

  X:=Random(MaxX);     Y:=Random(MaxY);
  W:=X+Random(MaxX-X); H:=Y+Random(MaxY-Y);

  R:=Random(255); G:=Random(255); B:=Random(255);

  Color:=RGB(R,G,B);

  If SolidColors Then Color:=GetNearestColor(PaintDC,Color);

  OldBrush:=SelectObject(PaintDC,CreateSolidBrush(Color));
  //------
  OldPen:=SelectObject(PaintDC,GetStockObject(null_Pen));
  //------

  if BlockType=3 then N:=Random(3) else N:=BlockType;
  
  case N of
    0:Rectangle(PaintDC,X,Y,W,H);
    1:RoundRect(PaintDC,X,Y,W,H,20,20);
    2:Ellipse(PaintDC,X,Y,W,H);
  end;
  
  Pro:=Random(2)=0;

  while (X+6<W)and(Y+6<H) do
  begin

    dec(W,2); dec(H,2);
    inc(X,2); inc(Y,2);

    if Pro then
    begin
      if R<=250 then R:=R+5;
      if G<=250 then G:=G+5;
      if B<=250 then B:=B+5;
    end
    else
    begin
      if R>=5 then R:=R-5;
      if G>=5 then G:=G-5;
      if B>=5 then B:=B-5;
    end;

    Color:=RGB(R,G,B);
    If SolidColors Then Color:=GetNearestColor(PaintDC,Color);
    
    DeleteObject(SelectObject(PaintDC,CreateSolidBrush(Color)));
    //-------
    case N of
      0:Rectangle(PaintDC,X,Y,W,H);
      1:RoundRect(PaintDC,X,Y,W,H,20,20);
      2:Ellipse(PaintDC,X,Y,W,H);
    end;
  end;
  
  SelectObject(PaintDC,OldPen);
  DeleteObject(SelectObject(PaintDC,OldBrush));
  EndPaint(PreviewWindow,Info);
End;
//-----   
Procedure RunSetPassword;
Var
  Lib : THandle;
  F   : TPCPAFunc;
Begin
  Lib:=LoadLibrary('MPR.DLL');
  If Lib>32 Then
  Begin
    @F:=GetProcAddress(Lib,'PwdChangePasswordA');
    If @F<>nil Then F('SCRSAVE',MyStrToInt(ParamStr(2)),0,0);
    FreeLibrary(Lib);
  End;
End;
//-----    
Procedure LoadSettings;
Var
  Key   : hKey;
  D1,D2 : Integer; { two dummies }
  V1    : byte;
  V2    : boolean;
  V3    : integer;
Begin
  If RegOpenKeyEx(hKey_Current_User,
                  'Software\SilverStream\SSBoxes',
                  0,Key_Read,Key)=Error_Success Then
  Begin
    D2 := SizeOf(V1);
    If RegQueryValueEx(Key,'BlockType',nil,@D1,
                       @V1,@D2)=Error_Success Then BlockType:=V1;

    D2 := SizeOf(V2);
    If RegQueryValueEx(Key,'SolidColors',nil,@D1,@V2,
                       @D2)=Error_Success Then SolidColors:=V2;

    D2 := SizeOf(V3);
    If RegQueryValueEx(Key,'Delay',nil,@D1,@V3,
                       @D2)=Error_Success Then Delay:=V3;

    RegCloseKey(Key);
  End;
End;
//-----    
Procedure SaveSettings;
Var
  Key   : hKey;
  Dummy : Integer;
Begin
  If RegCreateKeyEx(hKey_Current_User,'Software\SilverStream\SSBoxes',
                     0,nil,Reg_Option_Non_Volatile,
                     Key_All_Access,nil,Key,
                     @Dummy)=Error_Success Then
  Begin
    RegSetValueEx(Key,'BlockType',0,Reg_Binary,
                  @BlockType,SizeOf(byte));
    RegSetValueEx(Key,'SolidColors',0,Reg_Binary,
                  @SolidColors,SizeOf(Boolean));
    RegSetValueEx(Key,'Delay',0,Reg_Binary,
                  @Delay,SizeOf(integer));
    RegCloseKey(Key);
  End;
End;
//-----   
Function SettingsDlgProc(Window : hWnd; Msg,WParam,LParam : Integer): Integer; StdCall;
var
  p:array[0..30]of char;
  i:integer;
  HScrol:THandle;
Begin
  Result:=0;
  Case Msg of
    wm_InitDialog:  // initialize the dialog box
      Begin
        //   
        SendMessage(Window,WM_SETICON,ICON_BIG,LoadIcon(HInstance,'MAINICON')) ;

        {p:='';
        SendMessage(GetDlgItem(Window,2),CB_ADDSTRING,0,LongInt(@p));
        p:='. ';
        SendMessage(GetDlgItem(Window,2),CB_ADDSTRING,0,LongInt(@p));
        p:='';
        SendMessage(GetDlgItem(Window,2),CB_ADDSTRING,0,LongInt(@p));
        p:=' ';
        SendMessage(GetDlgItem(Window,2),CB_ADDSTRING,0,LongInt(@p));

        p:=' ';
        SendMessage(GetDlgItem(Window,4),CB_ADDSTRING,0,LongInt(@p));
        p:=' RGB';
        SendMessage(GetDlgItem(Window,4),CB_ADDSTRING,0,LongInt(@p));}


        for i:=10 to 13 do    //    ComboBox  
        begin
          LoadString(HINSTANCE,i,p,30);
          SendMessage(GetDlgItem(Window,2),CB_ADDSTRING,0,LongInt(@p));
        end;

        for i:=14 to 15 do
        begin
          LoadString(HINSTANCE,i,p,30);
          SendMessage(GetDlgItem(Window,4),CB_ADDSTRING,0,LongInt(@p));
        end;

        //  ItemIndex
        SendMessage(GetDlgItem(Window,2),CB_SETCURSEL,BlockType,0);

        if SolidColors then SendMessage(GetDlgItem(Window,4),CB_SETCURSEL,0,0)
        else SendMessage(GetDlgItem(Window,4),CB_SETCURSEL,1,0);


        HScrol:=GetDlgItem(Window,10);
        SendMessage(HScrol,SBM_SETRANGE,0,1000);
        SendMessage(HScrol,SBM_SETPOS,1000-Delay,0);

      End;

    wm_Command:          //   
      If LoWord(WParam)=5 Then
      begin
        EndDialog(Window,idOK);
        BlockType:=SendMessage(GetDlgItem(Window,2),CB_GETCURSEL,0,0);
        SolidColors:=SendMessage(GetDlgItem(Window,4),CB_GETCURSEL,0,0)=0;
        Delay:=1000-GetScrollPos(GetDlgItem(Window,10),SB_CTL);
      end
      Else If LoWord(WParam)=6 Then EndDialog(Window,idCancel);

    //-----  
    WM_HSCROLL:
      begin
        HScrol:=GetDlgItem(Window,10);
        i:=GetScrollPos(HScrol,SB_CTL);
        if HWND(LParam)=HScrol Then
        case LOWORD(wParam) of
          SB_THUMBTRACK :i:=HIWORD(wParam);
          SB_LINELEFT   :i:=i-10;
          SB_LINERIGHT  :i:=i+10;
          SB_PAGELEFT   :i:=i-50;
          SB_PAGERIGHT  :i:=i+50;
          else exit;
        end;
        if i<0 then i:=0 else if i>1000 then i:=1000;
        SetScrollPos(HScrol,SB_CTL,i,true);
     end;
     //---------------------

    wm_Close:DestroyWindow(Window);   //  

    wm_Destroy:PostQuitMessage(0);    //  
  End;
End;
//-----   
Procedure RunSettings;
Begin
  If DialogBox(hInstance,'SaverSettingsDlg',0,
               @SettingsDlgProc)=idOK Then SaveSettings;
End;
//-----    
Function AskPassword:Boolean;
Var
  Key   : hKey;
  D1,D2 : Integer; { two dummies }
  Value : Integer;
  Lib   : THandle;
  F     : TVSSPFunc;
Begin
  Result:=True;
  If RegOpenKeyEx(hKey_Current_User,'Control Panel\Desktop',0,
      Key_Read,Key)=Error_Success Then
  Begin
    D2:=SizeOf(Value);
    If RegQueryValueEx(Key,'ScreenSaveUsePassword',nil,@D1,
                       @Value,@D2)=Error_Success Then
    Begin
      If Value<>0 Then
      Begin
        Lib:=LoadLibrary('PASSWORD.CPL');
        If Lib>32 Then
        Begin
          @F:=GetProcAddress(Lib,'VerifyScreenSavePwd');
          ShowCursor(True);
          If @F<>nil Then Result:=F(PreviewWindow);
          ShowCursor(False);
          MoveCounter:=3; { reset again if password was wrong }
          FreeLibrary(Lib);
        End;
      End;
    End;
    RegCloseKey(Key);
  End;
End;

Function PreviewWndProc(Window:hWnd;Msg,WParam,LParam:Integer):Integer;StdCall;
Begin
  Result:=0;
  Case Msg of
    wm_NCCreate  : Result:=1;
    wm_Destroy   : PostQuitMessage(0);
    wm_Paint     : DrawSingleBox; { paint something }
    wm_KeyDown,
    wm_LButtonDown,
    wm_MButtonDown,
    wm_RButtonDown,
    wm_MouseMove : If Not IsPreview Then
                   Begin
                     Dec(MoveCounter);
                     If MoveCounter<=0 Then QuitSaver:=AskPassword;
                   End;
    {-------------
         
        
        -  
     -------------}
    Else Result:=DefWindowProc(Window,Msg,WParam,LParam);
  End;
End;
//-----   
Function CreateScreenSaverWindow(Width,Height:Integer;ParentWindow:hWnd):hWnd;
{Var
  WC:TWndClass;}
const         
  WC:TWndClass=(   //     
     Style         :cs_ParentDC;
     lpfnWndProc   :@PreviewWndProc;
     cbClsExtra    :0;
     cbWndExtra    :0;
     hInstance     :0;
     hIcon         :0;
     hCursor       :0;
     hbrBackground :0;
     lpszMenuName  :nil;
     lpszClassName :'MyDelphiScreenSaverClass');
Begin
{  With WC do
  Begin
    Style:=cs_ParentDC;
    lpfnWndProc:=@PreviewWndProc;
    cbClsExtra:=0;
    cbWndExtra:=0;
    hIcon:=0;
    hCursor:=0;
    hbrBackground:=0;
    lpszMenuName:=nil;
    lpszClassName:='MyDelphiScreenSaverClass';
  end;}
  
  WC.hInstance:=hInstance;

  RegisterClass(WC);

  If ParentWindow<>0 Then  //      
    Result:=CreateWindow('MyDelphiScreenSaverClass','MySaver',
                         WS_CHILD or WS_VISIBLE or WS_DISABLED,
                         0,0,Width,Height,
                         ParentWindow,0,hInstance,nil)
  Else
  Begin
    Result:=CreateWindow('MyDelphiScreenSaverClass','MySaver',
                         WS_VISIBLE or WS_POPUP,
                         0,0,Width,Height,
                         0,0,hInstance,nil);
    SetWindowPos(Result,hwnd_TopMost,0,0,0,0,
                 swp_NoMove or swp_NoSize or swp_NoRedraw);
  End;

  if Result=0 then Halt(0);   //    
End;

Function PreviewThreadProc(Data:Integer):Integer; StdCall;
Var
  R:TRect;
Begin
  Result:=0;
  Randomize;
  GetWindowRect(PreviewWindow,R);
  MaxX:=R.Right-R.Left;  MaxY:=R.Bottom-R.Top;

  ShowWindow(PreviewWindow,sw_Show);
  UpdateWindow(PreviewWindow);

  Repeat
    InvalidateRect(PreviewWindow,nil,False);
    Sleep(Delay);
  Until QuitSaver;
  
  PostMessage(PreviewWindow,wm_Destroy,0,0);
End;

Procedure RunPreview;
Var
  R            :TRect;
  ParentWindow :hWnd;
  Msg          :TMsg;
  Dummy        :Cardinal;
Begin
  IsPreview:=True;
  ParentWindow:=MyStrToInt(ParamStr(2));
  GetWindowRect(ParentWindow,R);
  
  PreviewWindow:=CreateScreenSaverWindow(R.Right-R.Left,R.Bottom-R.Top,ParentWindow);

  CreateThread(nil,0,@PreviewThreadProc,nil,0,Dummy);
  While GetMessage(Msg,0,0,0) do
  Begin
    TranslateMessage(Msg);
    DispatchMessage(Msg);
  End;
End;

Procedure RunFullScreen;
Var
  R          : TRect;
  Msg        : TMsg;
  Dummy      : Cardinal;
  Foreground : hWnd;
Begin
  IsPreview:=False;
  MoveCounter:=3;
  //      
  Foreground:=GetForegroundWindow;

  ShowCursor(False);  //  

  GetWindowRect(GetDesktopWindow,R);

  PreviewWindow:=CreateScreenSaverWindow(R.Right,R.Bottom,0);

  CreateThread(nil,0,@PreviewThreadProc,nil,0,Dummy);
  SystemParametersInfo(spi_ScreenSaverRunning,1,@Dummy,0);

  While GetMessage(Msg,0,0,0) do Begin
    TranslateMessage(Msg);
    DispatchMessage(Msg);
  End;

  SystemParametersInfo(spi_ScreenSaverRunning,0,@Dummy,0);

  ShowCursor(True);  //  

  //      
  SetForegroundWindow(Foreground);
End;

Procedure RunScreenSaver;
Var
  S:String;
  ch:char;
Begin
//  MessageBox(0,PChar(MyIntToStr(-12345)),'ParamStr(1)',0);
//  if MyStrToInt('1981')=1981 then MessageBox(0,'Ok','MyStrToInt',0);
//  exit;
//  MessageBox(0,PChar(S),'ParamStr(1)',0);

  LoadSettings; { load settings from registry }

  if ParamCount=0 then
  begin
    RunFullScreen;
    exit;
  end;

  S:=ParamStr(1);
  If Length(S)>1 Then ch:=UpCase(S[2]) else ch:=UpCase(S[1]);
  case ch of
    'C':RunSettings;
    'P':RunPreview;
    'A':RunSetPassword;
    else RunFullScreen;
  end;
End;
end.
